using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Vola.VolaSmsPlus;

namespace Sample_VolaSmsPlus
{
    public partial class frmCredit : Form
    {
        public frmCredit()
        {
            InitializeComponent();
        }

        private void CmdCredito_Click(object sender, EventArgs e)
        {
            try
            {
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Riceve il credito 
                String credito = Volasms.GetCreditSMS();
                MessageBox.Show("Il credito residuo : " + credito, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            catch (VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }

        }

        private void cmdClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void lnkVola_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage);
        }

        private void lnkSupporto_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport);
        }

        private void lnkLicenza_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                //Apre una shell del blocco di testo con la licenza
                string sPathUpdate = Application.StartupPath + "\\..\\..\\Licenza\\gplv3-it-final.pdf";

                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.EnableRaisingEvents = false;
                proc.StartInfo.FileName = sPathUpdate;
                proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized;
                proc.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdInformazioni_Click(object sender, EventArgs e)
        {
            try
            {
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;
                
                //Riceve le informazioni utente
                VolaProfiloUtente profilo = Volasms.GetProfile();
                MessageBox.Show("Il profilo utente  : " + profilo.profilo, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);

                //a questo punto  possibile leggere pure le altre informazioni utente
            }
            catch (VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}