using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Vola.VolaSmsPlus;

namespace Sample_VolaSmsPlus
{
    public partial class frmReciveSMS : Form
    {
        public frmReciveSMS()
        {
            InitializeComponent();
        }

        private void lnkVola_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage);
        }

        private void lnkSupporto_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport);
        }

        private void lnkLicenza_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                //Apre una shell del blocco di testo con la licenza
                string sPathUpdate = Application.StartupPath + "\\..\\..\\Licenza\\gplv3-it-final.pdf";

                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.EnableRaisingEvents = false;
                proc.StartInfo.FileName = sPathUpdate;
                proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized;
                proc.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void cmdAggiorna_Click(object sender, EventArgs e)
        {
            try
            {
                cmbKey.Items.Clear();
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Ottengo la lista delle chiavi di ricezione
                VolaProfiloUtente profilo = Volasms.GetProfile();

                if (profilo.ChiaviRicezione.Length == 0)
                {
                    MessageBox.Show("Non esistono chiavi di ricezioni attive", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                //Imposto i controlli
                for (int iCount = 0; iCount < profilo.ChiaviRicezione.Length; iCount++)
                {
                    cmbKey.Items.Add(profilo.ChiaviRicezione[iCount]);                    
                }
                cmbKey.SelectedIndex = 0;
            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }

        }

        private void cmdGetText_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbKey.Text.Length == 0)
                {
                    MessageBox.Show("Selezionare una chiave di ricezione e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Leggo l'autoresponder
                txtAutoresponder.Text = Volasms.GetAutoResponder(cmbKey.Text);

            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdSetText_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbKey.Text.Length == 0)
                {
                    MessageBox.Show("Selezionare una chiave di ricezione e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Imposto l'autoresponder
                if (Volasms.SetAutoResponder(cmbKey.Text, txtAutoresponder.Text))
                    MessageBox.Show("Testo autoresponder attivato correttamente", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show("Errore durante l'impostazione del testo autoresponder", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdCheck_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbKey.Text.Length == 0)
                {
                    MessageBox.Show("Selezionare una chiave di ricezione e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Leggo il numero di messaggi da ricevere
                int num = Volasms.CheckIncomingMessages(cmbKey.Text);
                if (num > -1)
                    if (num > 0)
                        MessageBox.Show("Ci sono " + num.ToString()+ " nuovi SMS da leggere", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    else
                        MessageBox.Show("Non ci sono nuovi SMS da leggere", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show("Errore durante la lattura del numeor dei nuovi SMS da leggere", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void CmdRecive_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbKey.Text.Length == 0)
                {
                    MessageBox.Show("Selezionare una chiave di ricezione e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Ricevo i messaggi
                ArrayList lista = Volasms.GetIncomingMessages(cmbKey.Text);

                if (lista == null)
                {
                    MessageBox.Show("Non ci sono nuovi SMS da leggere", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                //Imposto i controlli
                VolaMessaggio NuovoMessaggio;
                ListViewItem listItem;
                lstReciveSms.Items.Clear();
                IEnumerator Lista = lista.GetEnumerator();
                while (Lista.MoveNext())                
                {
                    NuovoMessaggio = (VolaMessaggio)Lista.Current;
                    listItem = lstReciveSms.Items.Add(NuovoMessaggio.mittente);
                    listItem.SubItems.Add(NuovoMessaggio.testo);
                    listItem.SubItems.Add(NuovoMessaggio.dataora);
                    listItem.SubItems.Add(DateTime.Now.ToString());
                    listItem.SubItems.Add(NuovoMessaggio.key);

                }

                //Cancello i messaggi ricevuti dal server
                if (Volasms.DelIncomingMessages(cmbKey.Text))
                    MessageBox.Show("Nuovi messaggi SMS letti correttamente", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    MessageBox.Show("Errore durante la lettura dei nuovi messaggi SMS", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}