using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Collections;
using System.Windows.Forms;

namespace Sample_VolaSmsPlus
{
    public partial class frmSendSMS : Form
    {
        public frmSendSMS()
        {
            InitializeComponent();
        }

        private void lnkVola_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage);
        }

        private void lnkSupporto_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport);
        }

        private void lnkLicenza_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                //Apre una shell del blocco di testo con la licenza
                string sPathUpdate = Application.StartupPath + "\\..\\..\\Licenza\\gplv3-it-final.pdf";

                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.EnableRaisingEvents = false;
                proc.StartInfo.FileName = sPathUpdate;
                proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized;
                proc.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CmdInvio_Click(object sender, EventArgs e)
        {
            try
            {
                string sMessage;
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //per effettuare test senza consumare il credito VolaSMS, la
                //propriet test mode deve essere impostata a true
                //in questo caso il messaggio SMS non viene recapitato, ma la comunicazione con
                //il gateway avviene regolarmente
                if (chkTest.Checked == true)
                    Volasms.TestMode = true;
                else
                    Volasms.TestMode = false;

                Volasms.ClearMessageToSend();

                //Se si vuole mnadare messaggi lunghi occore impostare l'opzione
                Volasms.LongMessage = true;

                //Aggiungo il messaggio nella lista
                //Se si hanno pi destinatari da mandare un messaggio uguale conviene passare un array di stringhe
                //come primo parametro per rendere il comando di invio pi veloce ed efficace.
                Vola.VolaSmsPlus.VolaMessaggio Messaggio = Volasms.AddMessageToSend(txtDestinatario.Text.Split(','), txtText.Text, cmbMittente.Text, DateTime.Now);
                if (Messaggio== null)
                {
                    sMessage = "Messaggio non inserito correttamente nella lista dei messaggi da inviare.";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                Vola.VolaSmsPlus.VolaMsdn Msdn =(Vola.VolaSmsPlus.VolaMsdn) Messaggio.listaDestinatari[0];
                if (Msdn.status != Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_INLIST)
                {
                    sMessage = "Messaggio non inserito correttamente nella lista dei messaggi da inviare.";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //E' possibile aggiungere pi messaggi alla lista in modo che con un unico invio  possibile mandare messaggi diversi a destintari diversi
                //Il numero massimo  1000

                //Prima di inviare controllo lo stato della lista
                if (Volasms.CountMessageToSend() <= 0)
                {
                    sMessage = "Impossibile continuare con l'invio di SMS perch non sono presenti messaggi corretti nella lista.";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //Invio il messaggio
                if (Volasms.SendMessageToSend() == false)
                {
                    sMessage = "Messaggio non inviato correttamente";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //Verifico lo stato del messaggio inviato
                switch (Msdn.status)
                {
                    case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRPHONEGSM:
                        sMessage = "Messaggio non inviato al numero: " + Msdn.gsm + " perch il destinatarrio non  corretto";
                        break;
                    case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRDATETIME:
                        sMessage = "Messaggio non inviato al numero: " + Msdn.gsm + " perch la data e ora erano nel formato non  corretto";
                        break;
                    case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRGATEWAY:
                        sMessage = "Messaggio non inviato al numero: " + Msdn.gsm + " perch scartato dal Gateway";
                        break;
                    case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRSENDER:
                        sMessage = "Messaggio non inviato al numero: " + Msdn.gsm + " perch il mittente  errato";
                        break;
                    case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRTEXT:
                        sMessage = "Messaggio non inviato al numero: " + Msdn.gsm + " perch incompleto";
                        break;
                    case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_SENT:
                        //il messaggio  andato a buon fine   
                        txtOrderid.Text = "";
                        for (int iCount =0; iCount < Messaggio.orderid.Length; iCount++)
                            txtOrderid.Text = txtOrderid.Text + Messaggio.orderid[iCount] + ",";
                        String credito = Volasms.GetCreditSMS();
                        sMessage = "Messaggio inoltrato. Il credito residuo di VolaPlus : " + credito;                       
                        break;
                    default:
                        sMessage = "Messaggio non inviato al numero: " + Msdn.gsm + " a causa di un errore nel protocollo";
                        break;
                }
                MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                         
            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdAggiorna_Click(object sender, EventArgs e)
        {
            try
            {
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;
                                          
                if (Volasms.CountListSender() == 0)
                    if (!Volasms.GetListSender())
                            MessageBox.Show("Errore nella ricezione della lista mittenti Vola\r\n\r\n", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);

                cmbMittente.Items.Clear();
                IEnumerator TEnumerator = Volasms.ListSender.GetEnumerator();
                Vola.VolaSmsPlus.VolaSender Mittente;
                for (int iCount = 1; iCount <= Volasms.ListSender.Count; iCount++)
                {
                    TEnumerator.MoveNext();

                    Mittente = (Vola.VolaSmsPlus.VolaSender)TEnumerator.Current;
                    cmbMittente.Items.Add(Mittente.mittente);
                    if (Mittente.type == Vola.VolaSmsPlus.VolaTypeSender.PREDEFINITO)
                        cmbMittente.Text = Mittente.mittente;
                }

                return;
            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}