'
'  Version: $RCSfile: VolaStructure.vb,v $ - $Revision: 1.2 $ - $Date: 2009/02/17 09:34:57 $
'
'  This file is part of VolaSmsPlus.
'
'   VolaSmsPlus is free software: you can redistribute it and/or modify
'   it under the terms of the GNU Lesser General Public License as published by
'   the Free Software Foundation, either version 3 of the License.
' 
'   VolaSmsPlus is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU Lesser General Public License for more details.
'
'   You should have received a copy of the GNU Lesser General Public License
'   along with VolaSmsPlus.  If not, see <http://www.gnu.org/licenses/>.
'

Imports System
Imports System.Text
Imports System.Collections

Namespace Vola.VolaSmsPlus
    ''' <summary>
    ''' Elenco Errori Vola
    ''' </summary>
    Public Enum VolaError
        VOLASMSPLUS_OK = 1
        VOLASMSPLUS_ERROR_AUTHENTICATION = 99
        VOLASMSPLUS_ERROR_CGI = 98
        VOLASMSPLUS_ERROR_CREDIT = 97
        VOLASMSPLUS_ERROR_GATEWAY = 96
        VOLASMSPLUS_ERROR_SENTSMS = 95
        VOLASMSPLUS_ERROR_VAPCODE = 94
        VOLASMSPLUS_ERROR_AUTORESPONDER = 93
        VOLASMSPLUS_ERROR_WRONG = 88
        VOLASMSPLUS_ERROR_COMMAND = 89
        VOLASMSPLUS_ERROR_SENDER_LIMIT_REACHED = 40
        VOLASMSPLUS_ERROR_SENDER_AUTH = 41
        VOLASMSPLUS_ERROR_SENDER_PINCODE = 42
        VOLASMSPLUS_ERROR_SENDER_PINCODE2 = 43
        VOLASMSPLUS_ERROR_SENDER_ALREADY_EXIST = 44
        VOLASMSPLUS_ERROR_SENDER_LIST_KO = 45
        VOLASMSPLUS_ERROR_SENDER_BLOCK = 46
        VOLASMSPLUS_ERROR_SENDER_INVALID = 47
        VOLASMSPLUS_ERROR_NETWORK = 10
        VOLASMSPLUS_ERROR_GENERIC = 11
        VOLASMSPLUS_ERROR_PROXY = 13
    End Enum

    ''' <summary>
    ''' Informazioni utente Vola
    ''' </summary>
    Public Structure VolaProfiloUtente
        Private _profilo As String
        Private _CreditoSms As String
        Private _CreditoMms As String
        Private _LicenzaVolaOffice As String
        Private _MittentePredefinito As String
        Private _ServizioNotificheUtente As Boolean
        Private _ServizioNotificheServer As Boolean
        Private _ServizioEstero As Boolean
        Private _ChiaviRicezione As String()
        Private _MittentiVola As String
        Private _MittentiDisabilitati As String
        Private _DataScadenzaCredito As String
        Private _ListaMittenti As String

        ''' <summary>
        ''' Valore stringa che pu assume S = GOLD L = SILVER
        ''' </summary>
        Public Property profilo() As String
            Get
                Return _profilo
            End Get
            Set(ByVal value As String)
                _profilo = value
            End Set
        End Property

        ''' <summary>
        ''' Valore stringa con il credito utile per l'invio di SMS
        ''' </summary>
        Public Property CreditoSms() As String
            Get
                Return _CreditoSms
            End Get
            Set(ByVal value As String)
                _CreditoSms = value
            End Set
        End Property

        ''' <summary>
        ''' Valore stringa con il credito utile per l'invio di MMS
        ''' </summary>
        Public Property CreditoMms() As String
            Get
                Return _CreditoMms
            End Get
            Set(ByVal value As String)
                _CreditoMms = value
            End Set
        End Property

        ''' <summary>
        ''' Lista licenze Vola For Office; in disuso
        ''' </summary>
        Public Property LicenzaVolaOffice() As String
            Get
                Return _LicenzaVolaOffice
            End Get
            Set(ByVal value As String)
                _LicenzaVolaOffice = value
            End Set
        End Property

        ''' <summary>
        ''' Mittente predefinito Vola
        ''' </summary>
        Public Property MittentePredefinito() As String
            Get
                Return _MittentePredefinito
            End Get
            Set(ByVal value As String)
                _MittentePredefinito = value
            End Set
        End Property

        ''' <summary>
        ''' Servizio di notifiche abilitato per l'invio di SMS dell'utente
        ''' </summary>
        Public Property ServizioNotificheUtente() As Boolean
            Get
                Return _ServizioNotificheUtente
            End Get
            Set(ByVal value As Boolean)
                _ServizioNotificheUtente = value
            End Set
        End Property

        ''' <summary>
        ''' Servizio di notifiche abilitato per il gateway; in disuso
        ''' </summary>
        Public Property ServizioNotificheServer() As Boolean
            Get
                Return _ServizioNotificheServer
            End Get
            Set(ByVal value As Boolean)
                _ServizioNotificheServer = value
            End Set
        End Property

        ''' <summary>
        ''' Servizio di notifice abilitato per l'invio di SMS dell'utente
        ''' </summary>
        Public Property ServizioEstero() As Boolean
            Get
                Return _ServizioEstero
            End Get
            Set(ByVal value As Boolean)
                _ServizioEstero = value
            End Set
        End Property

        ''' <summary>
        ''' Lista chiave di ricezioni attive dell'utente
        ''' </summary>
        Public Property ChiaviRicezione() As String()
            Get
                Return _ChiaviRicezione
            End Get
            Set(ByVal value As String())
                _ChiaviRicezione = value
            End Set
        End Property

        ''' <summary>
        ''' Lista dei mittenti Vola validi; in disuso
        ''' </summary>
        Public Property MittentiVola() As String
            Get
                Return _MittentiVola
            End Get
            Set(ByVal value As String)
                _MittentiVola = value
            End Set
        End Property

        ''' <summary>
        ''' Lista dei mittenti Vola bloccati dl gateaway; in disuso
        ''' </summary>
        Public Property MittentiDisabilitati() As String
            Get
                Return _MittentiDisabilitati
            End Get
            Set(ByVal value As String)
                _MittentiDisabilitati = value
            End Set
        End Property

        ''' <summary>
        ''' Data di scadenza del credito SMS e MMS Vola
        ''' </summary>
        Public Property DataScadenzaCredito() As String
            Get
                Return _DataScadenzaCredito
            End Get
            Set(ByVal value As String)
                _DataScadenzaCredito = value
            End Set
        End Property

        ''' <summary>
        ''' Lista dei mittenti dell'utente; in disuso
        ''' </summary>
        Public Property ListaMittenti() As String
            Get
                Return _ListaMittenti
            End Get
            Set(ByVal value As String)
                _ListaMittenti = value
            End Set
        End Property
    End Structure


    ''' <summary>
    ''' Elenco dei possibili stati in cui si pu trovare un messaggio Vola
    ''' </summary>
    Public Enum VolaMsdnStatus
        MSDN_INLIST = 0
        MSDN_SENT = 1
        MSDN_SMSC = 2
        MSDN_DELIVERED = 3
        MSDN_ERROPERATOR = 4
        MSDN_ERRTEXT = -1
        MSDN_ERRSENDER = -2
        MSDN_ERRDATETIME = -3
        MSDN_ERRPHONEGSM = -4
        MSDN_ERRGATEWAY = -5
    End Enum

    ''' <summary>
    ''' Elenco delle possibili cause per cui un SMS non  stato recapito
    ''' </summary>
    Public Enum VolaMsdnReasonCode
        REASONCODE_OK = 1
        REASONCODE_UNKNOW = 2
        REASONCODE_LOK_OPERATOR = 3
        REASONCODE_ERROR_DELIVERY = 4
        REASONCODE_LOK_USER = 5
        REASONCODE_SIM_FULL = 6
        REASONCODE_ERROR_OPERATOR = 7
    End Enum

    ''' <summary>
    ''' Classe per un destinatario di un messaggio SMS
    ''' </summary>
    Public Class VolaMsdn
        Private _status As VolaMsdnStatus
        Private _gsm As String
        Private _reasoncode As VolaMsdnReasonCode
        Private _datatimestatus As String

        ''' <summary>
        ''' Costrutore
        ''' </summary>
        Public Sub New()
            _status = VolaMsdnStatus.MSDN_INLIST
            _datatimestatus = ""
            _reasoncode = VolaMsdnReasonCode.REASONCODE_OK
        End Sub

        ''' <summary>
        ''' Costrutore
        ''' </summary>
        ''' <param name="gsm"></param>
        Public Sub New(ByVal gsm As String)
            _status = VolaMsdnStatus.MSDN_INLIST
            _gsm = gsm
        End Sub

        ''' <summary>
        ''' Numero GSM
        ''' </summary>
        Public Property gsm() As String
            Get
                Return _gsm
            End Get
            Set(ByVal value As String)
                _gsm = value
            End Set
        End Property

        ''' <summary>
        ''' Stato del messaggio
        ''' </summary>
        Public Property status() As VolaMsdnStatus
            Get
                Return _status
            End Get
            Set(ByVal value As VolaMsdnStatus)
                _status = value
            End Set
        End Property

        ''' <summary>
        ''' Possibile cause di un messaggio non recapitato; solo quando si richiede lo stato di notifica
        ''' </summary>
        Public Property reasoncode() As VolaMsdnReasonCode
            Get
                Return _reasoncode
            End Get
            Set(ByVal value As VolaMsdnReasonCode)
                _reasoncode = value
            End Set
        End Property

        ''' <summary>
        ''' Data e ora dello stato in cui si trova il messaggio; solo quando si richiede lo stato di notifica
        ''' </summary>
        Public Property datatimestatus() As String
            Get
                Return _datatimestatus
            End Get
            Set(ByVal value As String)
                _datatimestatus = value
            End Set
        End Property
    End Class



    ''' <summary>
    ''' Classe messaggio SMS
    ''' </summary>
    Public Class VolaMessaggio
        Private _listaDestinatari As ArrayList
        Private _mittente As String
        Private _testo As String
        Private _dataora As String
        Private _cid As Integer
        Private _key As String
        Private _orderdId As String()

        ''' <summary>
        ''' Costruttore
        ''' </summary>
        Public Sub New()
            _listaDestinatari = New ArrayList()
        End Sub

        ''' <summary>
        ''' Lista dei destinatari
        ''' </summary>
        Public Property listaDestinatari() As ArrayList
            Get
                Return _listaDestinatari
            End Get
            Set(ByVal value As ArrayList)
                _listaDestinatari = value
            End Set
        End Property

        ''' <summary>
        ''' Mittente del messaggio
        ''' </summary>
        Public Property mittente() As String
            Get
                Return _mittente
            End Get
            Set(ByVal value As String)
                _mittente = value
            End Set
        End Property

        ''' <summary>
        ''' Chiave ricezione del messaggio
        ''' </summary>
        Public Property key() As String
            Get
                Return _key
            End Get
            Set(ByVal value As String)
                _key = value
            End Set
        End Property

        ''' <summary>
        ''' Testo del messaggio
        ''' </summary>
        Public Property testo() As String
            Get
                Return _testo
            End Get
            Set(ByVal value As String)
                _testo = value
            End Set
        End Property

        ''' <summary>
        ''' Data e ora del messaggio
        ''' </summary>
        Public Property dataora() As String
            Get
                Return _dataora
            End Get
            Set(ByVal value As String)
                _dataora = value
            End Set
        End Property

        ''' <summary>
        ''' Numero di identificazione SMS prima dell'invio
        ''' </summary>
        Public Property cid() As Integer
            Get
                Return _cid
            End Get
            Set(ByVal value As Integer)
                _cid = value
            End Set
        End Property
        ''' <summary>
        ''' Numero di identificazione SMS dopo invio SMS
        ''' </summary>
        Public Property orderid() As String()
            Get
                Return _orderdId
            End Get
            Set(ByVal value As String())
                _orderdId = value
            End Set
        End Property
    End Class



    ''' <summary>
    ''' Costanti Vola
    ''' </summary>
    Public Structure VolaConstant
        Private Vola As String
        Private Const LinkVola As String = "www.vola.it"
        Private Const Gateway As String = "sms.vola.it"
        Private Const LinkHome As String = "/index.php"
        Private Const Support As String = "/supporto/index.php"
        Private Const _VolaAddressGateway As String = "sms.vola.it/cgi/volasms_gw_plus2.php"
        Private Const _SerialCode As String = "TR45GDLBO730HDUIEQJ5"
        Private Const _HttpProtocol As String = "http://"
        Private Const _HttpsProtocol As String = "https://"
        Private Const _Methode As String = "POST"
        Private Const _ContentType As String = "application/x-www-form-urlencoded"
        Private Const _CaractOK As String = "[A-Za-z0-9" & vbLf & " !""#$%&'()+,-./:;<=>?@[\]^_`{|}~ߧ]"

        Private Const _CaractDouble As String = "[,\,],^,{,|,},~,"
        Private Const _SeparatorBlock As String = vbTab
        Private Const _SeparatorPhone As String = ","
        Private Const _SeparatorGroup As String = vbCr & vbLf
        Private Const _SeparatorNotify1 As String = ":"
        Private Const _SeparatorNotify2 As String = ";"
        Private Const _SeparatorSender1 As Char = ","c
        Private Const _SeparatorSender2 As Char = ":"c
        Private Const _SeparatorRespost1 As Char = ControlChars.Tab
        Private Const _SeparatorRespost2 As Char = ";"c
        Private Const _SeparatorRespost3 As Char = ","c
        Private Const _SeparatorProfilo1 As Char = ControlChars.Tab
        Private Const _SeparatorProfilo2 As Char = ","c
        Private Const _SeparatorRecive1 As Char = ChrW(31)
        Private Const _SeparatorRecive2 As Char = ControlChars.Tab
        Private Const _SeparatorResNotify1 As String = vbCr & vbLf
        Private Const _SeparatorResNotify2 As Char = ControlChars.Tab
        Private Const _SeparatorResNotify3 As Char = ";"c
        Private Const _SeparatorResNotify4 As Char = ","c

        Public Shared ReadOnly Property SeparatorResNotify4() As Char
            Get
                Return _SeparatorResNotify4
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorResNotify3() As Char
            Get
                Return _SeparatorResNotify3
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorResNotify2() As Char
            Get
                Return _SeparatorResNotify2
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorResNotify1() As String
            Get
                Return _SeparatorResNotify1
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorRecive1() As Char
            Get
                Return _SeparatorRecive1
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorRecive2() As Char
            Get
                Return _SeparatorRecive2
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorProfilo1() As Char
            Get
                Return _SeparatorProfilo1
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorProfilo2() As Char
            Get
                Return _SeparatorProfilo2
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorRespost1() As Char
            Get
                Return _SeparatorRespost1
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorRespost2() As Char
            Get
                Return _SeparatorRespost2
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorRespost3() As Char
            Get
                Return _SeparatorRespost3
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorSender2() As Char
            Get
                Return _SeparatorSender2
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorSender1() As Char
            Get
                Return _SeparatorSender1
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorNotify1() As String
            Get
                Return _SeparatorNotify1
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorNotify2() As String
            Get
                Return _SeparatorNotify2
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorGroup() As String
            Get
                Return _SeparatorGroup
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorPhone() As String
            Get
                Return _SeparatorPhone
            End Get
        End Property
        Public Shared ReadOnly Property SeparatorBlock() As String
            Get
                Return _SeparatorBlock
            End Get
        End Property
        Public Shared ReadOnly Property CaractTextOK() As String
            Get
                Return _CaractOK
            End Get
        End Property
        Public Shared ReadOnly Property CaractDouble() As String
            Get
                Return _CaractDouble
            End Get
        End Property
        Public Shared ReadOnly Property Methode() As String
            Get
                Return _Methode
            End Get
        End Property
        Public Shared ReadOnly Property ContentType() As String
            Get
                Return _ContentType
            End Get
        End Property
        Public Shared ReadOnly Property HttpProtocol() As String
            Get
                Return _HttpProtocol
            End Get
        End Property
        Public Shared ReadOnly Property HttpVolaAddressGateway() As String
            Get
                Return HttpProtocol + _VolaAddressGateway
            End Get
        End Property
        Public Shared ReadOnly Property HttpsVolaAddressGateway() As String
            Get
                Return _HttpsProtocol + _VolaAddressGateway
            End Get
        End Property
        Public Shared ReadOnly Property SerialCode() As String
            Get
                Return _SerialCode
            End Get
        End Property

        Public Shared ReadOnly Property LinkHomePage() As String
            Get
                Return _HttpsProtocol + LinkVola
            End Get
        End Property

        Public Shared ReadOnly Property LinkSupport() As String
            Get
                Return _HttpsProtocol + LinkVola + Support
            End Get
        End Property
    End Structure


    ''' <summary>
    ''' Eccezione che pu essere generata dalla classe Volasmsplus durante l'invio dei messaggi
    ''' </summary>
    Public Class VolaException
        Inherits ApplicationException
        Private _messaggio As String
        Private _codice As VolaError

        ''' <summary>
        ''' Costruttore
        ''' </summary>
        ''' <param name="messaggio">Valore stringa descrizione dell'errore</param>
        ''' <param name="codice">Valore intero codice dell'errore</param>
        Public Sub New(ByVal messaggio As String, ByVal codice As VolaError)
            MyBase.New(messaggio)
            _messaggio = messaggio
            _codice = codice
        End Sub

        ''' <summary>
        ''' Descrizione dell'errore
        ''' </summary>
        Public ReadOnly Property Messaggio() As String
            Get
                Return _messaggio
            End Get
        End Property

        ''' <summary>
        ''' Codice dell'errore
        ''' </summary>
        Public ReadOnly Property Codice() As VolaError
            Get
                Return _codice
            End Get
        End Property
    End Class

    ''' <summary>
    ''' Classe mittente dei messaggi
    ''' </summary>
    Public Structure VolaSender
        Private _mittente As String
        Private _type As VolaTypeSender

        ''' <summary>
        ''' Mittente
        ''' </summary>
        Public Property mittente() As String
            Get
                Return _mittente
            End Get
            Set(ByVal value As String)
                _mittente = value
            End Set
        End Property

        ''' <summary>
        ''' Tipo mittente
        ''' </summary>
        Public Property type() As VolaTypeSender
            Get
                Return _type
            End Get
            Set(ByVal value As VolaTypeSender)
                _type = value
            End Set
        End Property
    End Structure

    ''' <summary>
    ''' Elenco tipi mittenti
    ''' </summary>
    Public Enum VolaTypeSender As Short
        PREDEFINITO = 1
        VOLA = 2
        AUTENTICATO = 3
        DA_AUTENTICARE = 4
        ERRATO = 5
    End Enum
End Namespace

