Imports Sample_VolaSmsPlus_VB.Vola.VolaSmsPlus

Public Class frmSender

    Private Sub lnkVola_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkVola.LinkClicked
        'Apre una shell del browser con il sito di Vola
        System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage)
    End Sub

    Private Sub lnkSupporto_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkSupporto.LinkClicked
        'Apre una shell del browser con il sito di Vola
        System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport)
    End Sub

    Private Sub lnkLicenza_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkLicenza.LinkClicked
        Try
            'Apre una shell del blocco di testo con la licenza
            Dim sPathUpdate As String = Application.StartupPath + "\..\..\Licenza\gplv3-it-final.pdf"

            Dim proc As New System.Diagnostics.Process()
            proc.EnableRaisingEvents = False
            proc.StartInfo.FileName = sPathUpdate
            proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized
            proc.Start()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Me.Close()
    End Sub



    Private Sub cmdAutentica_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdAutentica.Click
        Try

            If txtPincode.Text.Length = 0 Then
                MessageBox.Show("Inserire il codice PINCODE e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            Dim Volasms As New Vola.VolaSmsPlus.VolaSmsPlus()

            'Inizializzo il componente con le propriet di autenticazione
            Volasms.UserName = txtUsername.Text
            Volasms.Password = txtPassword.Text
            Volasms.VapCode = ""

            'Inizializzo il componente con le propriet di connessione
            Volasms.AutomaticProxy = True
            Volasms.EncryptSSL = True

            'autentico il mittente
            If Volasms.AuthenticateSender(txtAutenticare.Text, txtPincode.Text) Then
                AggiornaListaMittenti()
                txtAutenticare.Text = ""
                txtPincode.Text = ""
                MessageBox.Show("Mittente autenticato e pronto per essere utilizzato nell'invio di SMS.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                AggiornaListaMittenti()
                MessageBox.Show("Errore durante l'auteticazione del mittente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Catch ex As Vola.VolaSmsPlus.VolaException
            MessageBox.Show(("Errore libreria Vola: " & ex.Codice & vbCr & vbLf & vbCr & vbLf) + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try

    End Sub

    Private Sub cmdAggiungi_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdAggiungi.Click
        Try
            If txtAggiungi.Text.Length = 0 Then
                MessageBox.Show("Inserire il mittente da aggiungere alla lista e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            Dim Volasms As New Vola.VolaSmsPlus.VolaSmsPlus()

            'Inizializzo il componente con le propriet di autenticazione
            Volasms.UserName = txtUsername.Text
            Volasms.Password = txtPassword.Text
            Volasms.VapCode = ""

            'Inizializzo il componente con le propriet di connessione
            Volasms.AutomaticProxy = True
            Volasms.EncryptSSL = True

            'Verifico il tipo del mittente
            Dim NuovoMittente As String = txtAggiungi.Text
            NuovoMittente = Vola.VolaSmsPlus.VolaCheckGsm.CheckGSMNumber(NuovoMittente, Vola.VolaSmsPlus.VolaCheckGsm.FormatGsm.PLUS_COUNTRY_MSDN)
            If NuovoMittente.Length = 0 Then
                'Mittente alfanumerico
                If Volasms.AddSender(txtAggiungi.Text) Then
                    AggiornaListaMittenti()
                    txtAggiungi.Text = ""
                    MessageBox.Show("Mittente aggiunto correttamente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Else
                    AggiornaListaMittenti()
                    MessageBox.Show("Errore durante l'inserimento del mittente alla lista.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            Else
                'Mittente numerico
                Dim risposta As Integer = Volasms.AddSenderGsm(txtAggiungi.Text)
                AggiornaListaMittenti()
                Select Case risposta
                    Case -1
                        MessageBox.Show("Errore durante l'inserimento del mittente alla lista.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Exit Select
                    Case 0
                        txtAggiungi.Text = ""
                        MessageBox.Show("Al numero mittente  stato inviato un SMS con un codice PINCODE utile per autenticare l'inserimento dello stesso all'interno della lista.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Exit Select
                    Case 1
                        MessageBox.Show("Mittente aggiunto correttamente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Exit Select
                End Select
            End If

        Catch ex As Vola.VolaSmsPlus.VolaException

            MessageBox.Show(("Errore libreria Vola: " & ex.Codice & vbCr & vbLf & vbCr & vbLf) + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub cmdRimuovi_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdRimuovi.Click
        Try
            If cmbMittente.Text.Length = 0 Then
                MessageBox.Show("Selezionare il mittente da rimuovere dalla lista e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            Dim Volasms As New Vola.VolaSmsPlus.VolaSmsPlus()

            'Inizializzo il componente con le propriet di autenticazione
            Volasms.UserName = txtUsername.Text
            Volasms.Password = txtPassword.Text
            Volasms.VapCode = ""

            'Inizializzo il componente con le propriet di connessione
            Volasms.AutomaticProxy = True
            Volasms.EncryptSSL = True

            'Rimuovo il mittente
            If Volasms.RemoveSender(cmbMittente.Text) Then
                AggiornaListaMittenti()
                MessageBox.Show("Mittente rimosso correttamente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                AggiornaListaMittenti()
                MessageBox.Show("Errore durante la rimozione del mittente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        Catch ex As Vola.VolaSmsPlus.VolaException
            MessageBox.Show(("Errore libreria Vola: " & ex.Codice & vbCr & vbLf & vbCr & vbLf) + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub CmdUpdate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CmdUpdate.Click
        AggiornaListaMittenti()
    End Sub

    Private Sub AggiornaListaMittenti()
        Try
            Dim Volasms As New Vola.VolaSmsPlus.VolaSmsPlus()

            'Inizializzo il componente con le propriet di autenticazione
            Volasms.UserName = txtUsername.Text
            Volasms.Password = txtPassword.Text
            Volasms.VapCode = ""

            'Inizializzo il componente con le propriet di connessione
            Volasms.AutomaticProxy = True
            Volasms.EncryptSSL = True

            'Leggo la lista dei mittenti
            If Not Volasms.GetListSender() Then
                MessageBox.Show("Errore nella ricezione della lista mittenti Vola" & vbCr & vbLf & vbCr & vbLf, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

            'Aggiorno i controlli con i dati
            cmbMittente.Items.Clear()
            txtAutenticare.Text = ""
            Dim TEnumerator As IEnumerator = Volasms.ListSender.GetEnumerator()
            Dim Mittente As Vola.VolaSmsPlus.VolaSender
            For iCount As Integer = 1 To Volasms.ListSender.Count
                TEnumerator.MoveNext()

                Mittente = DirectCast(TEnumerator.Current, Vola.VolaSmsPlus.VolaSender)
                cmbMittente.Items.Add(Mittente.mittente)
                If Mittente.type = Vola.VolaSmsPlus.VolaTypeSender.PREDEFINITO Then
                    txtPredefinito.Text = Mittente.mittente
                Else
                    cmbMittente.Text = Mittente.mittente
                End If

                If Mittente.type = Vola.VolaSmsPlus.VolaTypeSender.DA_AUTENTICARE Then
                    txtAutenticare.Text = Mittente.mittente
                End If
            Next

            If txtAutenticare.Text.Length = 0 Then
                cmdAutentica.Enabled = False
                txtAutenticare.Enabled = False

            Else
                txtPincode.Enabled = True
                cmdAutentica.Enabled = True
            End If

        Catch ex As Vola.VolaSmsPlus.VolaException
            MessageBox.Show(("Errore libreria Vola: " & ex.Codice & vbCr & vbLf & vbCr & vbLf) + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub


End Class